#ifndef Control_included
#define Control_included

#include "ControlData.h"
#include <qdir.h>
#include "EMHist.h"
#include "InspDir.h"
#include "InspHist.h"
#include "InspFile.h"
#include "InspCls.h"
#include "InspTri.h"
#include "Axes2d.h"
#include "LSPlot.h"
#include "DataSet.h"

class Control : public ControlData
{
    Q_OBJECT

	QList<EMHist> histlist;
	QList<QListViewItem> qlvlist;

	Axes2d *convaxes;
	QList<DataSet> convdata;
	QList<LSPlot> convplot;

	int curinsp;

	QString curfile;
	QString curdir;
	QString curfilt;
	QFileInfo dirfi;
	QDateTime dtime;
	int tmrct;

public:

    Control(QWidget* parent = NULL,const char* name = NULL);

    virtual ~Control();
	virtual void timerEvent(QTimerEvent *);


	InspFile ifile;
	InspDir  idir;
	InspHist ihist;
	InspCls	 icls;
	InspTri  itri;


signals:

public slots:
//	void addDir();
	void fileSel(QListViewItem *qlv);
	void dirUpdate();
	void dirBrow();
	void dispDir(const QString&);
	void dispFile(const char *file);
	void dispCls(const char *file);
	void dispTri(const char *file);
	void dispHist();
	void histSel(QListViewItem *qlv);
//	void procDList();
	void quit();
	void showTab(int i);
	void showInsp(int);
	void doConverge();
};
#endif // Control_included
