#include "PyList.h"

template<class T>
void list2array(const PyList& l, T* array)
{
    if (!array) {
	return;
    }
    for (int i = 0; i < l.size(); i++) {
	array[i] = BOOST_PYTHON_CONVERSION::from_python(l.get_item(i).get(),
							boost::python::type<T>());
    }
}


template<class T>
void array2list(const T* array, PyList& l)
{
    if (!array) {
	return;
    }
    for (int i = 0; i < l.size(); i++) {
	l[i] = array[i];
    }
}

template void list2array<float>(const PyList& l, float* array);
template void array2list<float>(const float* array, PyList& l);

template void list2array<int>(const PyList& l, int* array);
template void array2list<int>(const int* array, PyList& l);

template void list2array<const char*>(const PyList& l, const char** array);
//template void array2list<const char*>(const (const char*) * array, PyList& l);
