#include <stdio.h>
#include <math.h>
#include "EMData.h"
#include "List.h"
#include "util.h"

main(int argc, char *argv[]) {
int i, ix, iy, IMAX, iloop=0;
int nx,ny;
List *dlist, *dlistorig;
EMData *d, *d2;
float *data,pi=3.1415926;
float x, y, r, qstar=1./30;
float temp, sum, sumx, sumy, sumxx,sumxy,sumyy, dev;
float X,Y,XX,XY, YY;
float trace, det, sigmax, sigmay;
float sin2alpha, alpha[500],query;

appinit(argc,argv);

if (argc<2) { printf("moments.c\n Usage: moments <input file> output=CMomresult.img\n"); exit(0); }

unlink("CMomresult.hed");
unlink("CMomresult.img");

dlist = new List;   dlistorig = new List;	// list to put the individual images in


dlist = readImages(argv[1],0,-1); dlistorig = readImages(argv[1],0,-1);
IMAX= dlist->count();

for (i=0;i<IMAX;i++) alpha[i]=0;  // alpha[i]

printf("%d images read\n",dlist->count());

//                           Here we multiply by Bessel function
//                             and write the new image to a file
for (i=0; i< IMAX; i++) { 
	d2=(EMData *)dlistorig->objectAt(i);
	d=(EMData *)dlist->objectAt(i);
	d=d2->copy();
  	d->setRAlign(-alpha[i],0,0); d->rotateAndTranslate();
//	if (iloop==0) d->writeIMAGIC("CMomresult.hed",-1);	// -1 appends to an imagic file		
	data=d->getData();
        nx=d->xSize();
        ny=d->ySize();
        for(ix=0;ix<nx; ix++) { for(iy=0;iy<ny; iy++) {
	        x = ix -nx/2 +1; y = iy -ny/2 +1;
		r = sqrt(x*x + y*y) ;
		temp = data[ix+iy*nx]; 
		temp = temp*temp *exp(-(qstar*r)*(qstar*r)) ;
		data[ix+iy*nx] = temp ;
	}}
	d->doneData();	
//	d->writeIMAGIC("CMomresult.hed",-1);	// -1 appends to an imagic file	
//	d->applyMask(-1,1);
}        printf("finished multiplying by weighting function=1 \n");

//                Here we cacluate moments if r < nx/2              
//	
for (i=0; i< IMAX; i++) { 
        sum =0; sumx=0; sumy=0; sumxx=0,sumyy=0;sumxy=0; dev=0;
	d2=(EMData *)dlistorig->objectAt(i);
	d=(EMData *)dlist->objectAt(i);
	d=d2->copy();
  	d->setRAlign(-alpha[i],0,0); d->rotateAndTranslate();
	data=d->getData();
        for(ix=0;ix<nx; ix++) { for(iy=0;iy<ny; iy++) {
	        x = ix -nx/2 ; y = iy -ny/2; r = sqrt(x*x + y*y);
		if (r<nx/2) {
			temp = data[ix+iy*nx]; 
			sum   += temp;
			sumx  += x*temp;
			sumy  += y*temp; 
			sumxx += x*x*temp; 
			sumxy += x*y*temp;
			sumyy += y*y*temp; 
			dev   += temp*temp;
		}
	}}
	d->doneData();
	sum =sum/(nx*ny); X = sumx/(nx*ny); Y = sumy/(nx*ny);
	XX = sumxx/(nx*ny); XY = sumxy/(nx*ny); YY = sumyy/(nx*ny);


	XX = (XX*sum - X*X);  XY = (XY*sum - X*Y);  YY = (YY*sum - Y*Y);
	trace = (XX + YY) ;  det = (XX * YY -XY*XY) ;
	
	sigmax = trace/2. + sqrt((XX-YY)*(XX-YY)/4. +XY*XY);
	sigmay = trace/2. - sqrt((XX-YY)*(XX-YY)/4. +XY*XY);

     sin2alpha   = (XY*2)/(sigmay-sigmax);
      if (sin2alpha >1) sin2alpha =1;
      if (sin2alpha <-1) sin2alpha = -1;

     alpha[i] += (asin(sin2alpha))/2;
//	if (XY>0) alpha[i] = -alpha[i];	
	if (YY*YY>XX*XX) alpha[i] += 3.1415926/2;
	
//	printf("\n\n pic no.=%d, X= %f, Y=%f, XX=%f; XY =%f, YY=%f \n\n", i+1,X,Y,XX,XY,YY);
//	printf("R xx = %f, R xy = %f, Ryy = %f \n\n ", XX, XY, YY); 
//	printf("trace = %f, det = %f \n\n ", trace, det); 
//      printf("ave. dens. squared dev  = %f\n\n ",(dev/(nx*ny))); 
//      printf(" %f	%f	%f \n\n ",alpha[i],sigmax,sigmay);  
      	query = sqrt(XY*XY/(XX*XX));
	if (query > 0.02) i += -1;   // do it again
	iloop +=1;
	if (query < 0.02) iloop =0;
}
	printf(" \n\n\n");
	
for (i=0; i<IMAX; i++) {
	printf(" pic no.=%d,	alpha=%f \n", i+1,180*alpha[i]/pi);
	d2 = (EMData *)dlistorig->objectAt(i);		// get an image from the list
	d  = (EMData *)dlist    ->objectAt(i);		// get an image from the list
	d=d2->copy();
//	alpha[i]=0;
  	d->setRAlign(-alpha[i],0,0); d->rotateAndTranslate(); d->writeIMAGIC("CMomresult.img",-1);
//  	d2->setRAlign(-alpha[i],0,0); d2->rotateAndTranslate(); d2->writeIMAGIC("CMomresult.img",-1);	
//  	d2->setRAlign(180+alpha[i],0,0); d2->rotateAndTranslate(); d2->writeIMAGIC("CMomresult.img",-1);
//	d2->setRAlign(180-alpha[i],0,0); d2->rotateAndTranslate(); d2->writeIMAGIC("CMomresult.img",-1);	
	} // write final output file

}  // ends program
