#include "D2Inspector.h"
#include "InspArea.h"
#include "InspAxis.h"
#include "InspPlot.h"

#define Inherited D2InspectorData

D2Inspector::D2Inspector(QWidget* parent,const char* name):Inherited( parent, name ) {
	setCaption( "2D Plot Inspector" );

	InspArea *i0;
	InspAxis *i1;
	InspAxis *i2;
	InspPlot *i3;

	insp[0]=i0=new InspArea;
	insp[1]=i1=new InspAxis;
	insp[2]=i2=new InspAxis;
	insp[3]=i3=new InspPlot;
	
	i2->setAxis(1);

	stack->addWidget(i0,0);
	stack->addWidget(i1,1);
	stack->addWidget(i2,2);
	stack->addWidget(i3,3);

	ci=0;
	target=NULL;

	stack->setFrameStyle( QFrame::Panel | QFrame::Sunken );
}


D2Inspector::~D2Inspector() {
for (int i=0; i<4; i++) delete insp[i];
}

void D2Inspector::setTarget(Axes2d *t) {
if (target) disconnect(target,SIGNAL(changed()),this,SLOT(refresh()));
target=t;
insp[ci]->setTarget(target);
connect(target,SIGNAL(changed()),this,SLOT(refresh()));
}

void D2Inspector::tabSel(int n) {

if (n<0 || n>3) return;
ci=n;

insp[n]->setTarget(target);

stack->raiseWidget(n);
}
